# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.tests import BaseTest, get_example_worklist


class Advia1200Test(BaseTest):
    MAPPING_CLASS = "advia1200"

    def test_order(self):
        self.assertOrderMessageEqual(
            self.WORKLIST_NEW_ADD_DEL,
            """O 0101002N1123456              NYME            ANO             F  220130513 1.011  AM  BM """,
        )

    def test_order_nouveau(self):
        wk = get_example_worklist(
            [{"code": "A", "action": "new"}, {"code": "B", "action": "new"}]
        )
        self.assertOrderMessageEqual(
            wk,
            """O 0101002N0123456              NYME            ANO             F  220130513 1.011  AM  BM """,
        )

    def test_frame_size512(self):
        data = """R 020102120121025144711N0140210253056        CQ RIQAS        ADVIA1200       M  020121025 1.011 12M   0.459    XYZ 23M      40    XYZ  9M    13.8l   XYZ 15M    1.13    XYZ 11M    60.0    XYZ 14M    58.1    XYZ 22M     189    XYZ 21M     398    XYZ 20M     171    XYZ 19M      35    XYZ 18M      38    XYZ 17M    10.5    XYZ 16M    16.6    XYZ 10M    95.9    XYZ 13M   13.28    XYZ 25M      50    XYZ  2M       2    XYZ  3M       0    XYZ  4M       1    XYZ  6M     140    XYZ  7M    3.91    XYZ \r\nR 020200120121025144711N0140210253056          8M      96    XYZ """
        self.assertEqual(self.F.to_string(self.F.parse(data)), data)

    def test_void_order(self):
        self.assertVoidOrderEqual(
            (
                "Q 0201380440206039527 220206032129  \n"
                "Q 0202110220206032121 440206039563  "
            ),
            (
                "O 0101000N2440206039527                                        M   00000000 1.011 \n"
                "O 0101000N2220206032129                                        M   00000000 1.011 \n"
                "O 0101000N2220206032121                                        M   00000000 1.011 \n"
                "O 0101000N2440206039563                                        M   00000000 1.011 "
            ),
        )
