# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "chronos_ananke"


def test_decode_result(self):
    worklist = self.decode(
        """
        Export created by user,ADMIN avec des accents èà ^ðŋħĸ,
    Experiment name,Run 2021-06-24 11:08:51.122904,
    Description,,
    Note,Plaque1,
    Test,Covid BFORCURE AR4,
    Test type,RUO,
    Barcodes,{"sample_id": {"1": "Sars cov2 ssRNA~10^2 RPP30 10^3"}, "reagent_id": "Mix 2306 triplex covid", "chip_id": "aaaaapxm-E8|001|IVD"},
    Start date,2021-06-24 11:09:00,
    Database id,174,
    Chronos instrument,CHA1A7 31_1,
    Computer name,bforcure-LincPlus-P3,
    Ananke version,vDev,
    APF version,13,
    Analysis plugin version,2.3.2,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    ,,
    Chamber number,Chamber sample name,Chamber sample type,Channel 1 fluor,Channel 1 target name,Channel 1 type,Channel 1 Cq,Channel 2 fluor,Channel 2 target name,Channel 2 sample type,Channel 2 Cq,Channel 3 fluor,Channel 3 target name,Channel 3 sample type,Channel 3 Cq,Channel 4 fluor,Channel 4 target name,Channel 4 sample type,Channel 4 Cq,Interpretation,
    Chamber 1,1023354,,FAM,E,target,N/A,N/A,,target,N/A,TEXAS RED,N2,target,24.63,CY5,RnaseP,target,28.35,Positive,,
    Chamber 2,20235544,,FAM,E,target,N/A,N/A,,target,N/A,TEXAS RED,N2,target,N/A,CY5,RnaseP,target,N/A,,,
    Chamber 3,,,FAM,E,target,N/A,N/A,,target,N/A,TEXAS RED,N2,target,N/A,CY5,RnaseP,target,N/A,,,
    Chamber 4,,,FAM,E,target,N/A,N/A,,target,N/A,TEXAS RED,N2,target,N/A,CY5,RnaseP,target,N/A,,,
        """
    )
    date = datetime.datetime(2021, 6, 24, 11, 9)
    expected = {
        "context": "result",
        "samples": [
            {
                "rack": "Chamber 1",
                "results": [
                    {
                        "code": "FAM_E_1",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": ["Positive"],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "N/A",
                    },
                    {
                        "code": "TEXAS RED_N2_3",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": ["Positive"],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "24.63",
                    },
                    {
                        "code": "CY5_RnaseP_4",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": ["Positive"],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "28.35",
                    },
                    {
                        "code": "Export created by user",
                        "value": "ADMIN avec des accents èà ^ðŋħĸ",
                    },
                    {
                        "code": "Experiment name",
                        "value": "Run 2021-06-24 11:08:51.122904",
                    },
                    {"code": "Note", "value": "Plaque1"},
                    {"code": "Test type", "value": "RUO"},
                ],
                "sample_id": "1023354",
                "type": "patient",
            },
            {
                "rack": "Chamber 2",
                "results": [
                    {
                        "code": "FAM_E_1",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": [""],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "N/A",
                    },
                    {
                        "code": "TEXAS RED_N2_3",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": [""],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "N/A",
                    },
                    {
                        "code": "CY5_RnaseP_4",
                        "comments": ["Plaque1"],
                        "date": date,
                        "flags": [""],
                        "instrument": "CHA1A7 31_1",
                        "lots": [
                            {
                                "lot": "aaaaapxm-E8|001|IVD_Mix 2306 triplex covid",
                                "type": "reagent",
                            }
                        ],
                        "operator": "ADMIN avec des accents èà ^ðŋħĸ",
                        "value": "N/A",
                    },
                    {
                        "code": "Export created by user",
                        "value": "ADMIN avec des accents èà ^ðŋħĸ",
                    },
                    {
                        "code": "Experiment name",
                        "value": "Run 2021-06-24 11:08:51.122904",
                    },
                    {"code": "Note", "value": "Plaque1"},
                    {"code": "Test type", "value": "RUO"},
                ],
                "sample_id": "20235544",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
