# -*- coding: utf8 -*-
from __future__ import unicode_literals

import copy

parser_class = "gentiane"


def test_order(self):
    worklist = copy.deepcopy(self.order_worklist)
    worklist.samples[0]["results"].append({"code": "TRF", "value": "2.14"})
    message = self.order(worklist=worklist)
    expected = """
    0000;036666666;NYME/NJF;ANO;13;05;2011;F;11:42;13/05/2013;123456;45 rue lambda;lala;31000;Toulouse;PRESCRIBER;;3;A:42;B:201302131516;TRF:2.14
    """
    assert message == expected


def test_order_service(self):
    self.configure(service_prioritaire=True)
    worklist = copy.deepcopy(self.order_worklist)
    worklist.samples[0]["results"].append({"code": "TRF", "value": "2.14"})
    worklist.samples[0][
        "address"
    ] = "2000 rue de la d'adresse tres tres tres longue ~xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0xxxxx"
    message = self.order(worklist=worklist)
    expected = """
    0000;036666666;NYME/NJF;ANO;13;05;2011;F;11:42;13/05/2013;123456;2000 rue de la d'adresse tres tres tres ;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0;31000;Toulouse;PRESCRIBER;;3;A:42;B:201302131516;TRF:2.14
    """
    assert message == expected


def test_results_upload(self):
    worklist = self.decode(
        """
    SB0207SF406;IGM:166;IGG:84;IGA:256;
    1234568;IGM:111;IGG:88;IGA:255;
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {"code": "IGM", "value": "166"},
                    {"code": "IGG", "value": "84"},
                    {"code": "IGA", "value": "256"},
                    {"code": "", "value": ""},
                ],
                "sample_id": "SB0207SF406",
                "type": "patient",
            },
            {
                "results": [
                    {"code": "IGM", "value": "111"},
                    {"code": "IGG", "value": "88"},
                    {"code": "IGA", "value": "255"},
                    {"code": "", "value": ""},
                ],
                "sample_id": "1234568",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
