# -*- coding: utf8 -*-

from __future__ import unicode_literals

import datetime

parser_class = "poch"


def test_result(self):
    result = self.decode(
        """
    H|\\^&|||pocH-100i^00-00^^^^Sysmex pocH 01^12345678||||||||E1394-9
    P|1
    O|1||^^1234567890^A|^^^^WBC\\^^^^RBC\\^^^^HGB\\^^^^HCT\\^^^^MCV\\^^^^MCH\\^^^^MCHC\\^^^^PLT\\^^^^W-SCR\\^^^^W-MCR\\^^^^W-LCR\\^^^^W-SCC\\^^^^W-MCC\\^^^^W-LCC\\^^^^RDW-SD\\^^^^RDW-CV\\^^^  ^PDW\\^^^^MPV\\^^^^P-LCR|||||||N||||||||||||||F
    R|1|^^^^WBC^26|7.8|10*3/μL||N||||||20011221163530
    R|2|^^^^RBC^26|3.50|10*6/μL||L||||||20011221163530
    R|3|^^^^HGB^26|44.2|g/dL||A||||||20011221163530
    R|4|^^^^P-LCR^26|50.0|%||H||||||20011221163530
    L|1|N"""
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "sample_id": "1234567890",
                "type": "patient",
                "results": [
                    {
                        "flags": ["N"],
                        "date": datetime.datetime(2001, 12, 21, 16, 35, 30),
                        "value": "7.8",
                        "code": "WBC",
                    },
                    {
                        "flags": ["L"],
                        "date": datetime.datetime(2001, 12, 21, 16, 35, 30),
                        "value": "3.50",
                        "code": "RBC",
                    },
                    {
                        "flags": ["A"],
                        "date": datetime.datetime(2001, 12, 21, 16, 35, 30),
                        "value": "44.2",
                        "code": "HGB",
                    },
                    {
                        "flags": ["H"],
                        "date": datetime.datetime(2001, 12, 21, 16, 35, 30),
                        "value": "50.0",
                        "code": "P-LCR",
                    },
                ],
            }
        ],
    }
    assert result == expected
