# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "covid_results_csv"


def test_decode_result(self):
    worklist = self.decode(
        """
    Experiment: 2test clarilab;;;;;;;;;;
    Include;Color;Pos;Name;Cp;Cp VIC;Status;;Statut attendu;;
    True;65280;A1;A29008632985;;"25,92";;;N;;
    True;65280;A2;A29008632686;"28,28";"25,53";;;P;;
    True;65280;A3;A29008632387;;"28,81";;;I;;
    True;65280;A4;A29008632088;;"27,54";;;R;;
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {"code": "Cp VIC", "value": "25.92"},
                    {"code": "Statut attendu", "value": "N"},
                ],
                "sample_id": "A29008632985",
                "rack": "COVID-A1",
                "type": "patient",
            },
            {
                "results": [
                    {"code": "Cp", "value": "28.28"},
                    {"code": "Cp VIC", "value": "25.53"},
                    {"code": "Statut attendu", "value": "P"},
                ],
                "sample_id": "A29008632686",
                "rack": "COVID-A2",
                "type": "patient",
            },
            {
                "results": [
                    {"code": "Cp VIC", "value": "28.81"},
                    {"code": "Statut attendu", "value": "I"},
                ],
                "sample_id": "A29008632387",
                "rack": "COVID-A3",
                "type": "patient",
            },
            {
                "results": [
                    {"code": "Cp VIC", "value": "27.54"},
                    {"code": "Statut attendu", "value": "R"},
                ],
                "sample_id": "A29008632088",
                "rack": "COVID-A4",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
